package DX::ActionBuilder::BoundValue;

use DX::Action::SetBoundValue;
#use DX::Action::AddBoundValue;
use DX::Class;

with 'DX::Role::ActionBuilder';

has target_path => (is => 'ro', required => 1);

has rebind_path => (is => 'ro', required => 1);

has bound_to_path => (is => 'ro', required => 1);

has inner_action_builder => (is => 'ro', required => 1);

sub action_for_set_value {
  my ($self, $value) = @_;
  my $inner_action = $self->inner_action_builder->action_for_set_value($value);
  return undef unless $inner_action;
  DX::Action::SetBoundValue->new(
    target_path => $self->target_path,
    rebind_path => $self->rebind_path,
    new_value => $value->but_set_action_builder($self)
                       ->but_set_identity_path($self->bound_to_path),
    inner_action => $inner_action,
  )
}

1;
